<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               :search.sync="search"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="primary" size="small" icon="el-icon-download"
                   plain @click="handleDownload">下載
        </el-button>
      </template>

      <template slot="receiverNameForm">
        <select-dialog-user :name="form.receiverName" :ehr="form.receiverNo" :disabled="false" :callback="selectCallback"></select-dialog-user>
      </template>
      <template slot="handoverPersonNameForm">
        <select-dialog-user :name="form.handoverPersonName" :ehr="form.handoverPersonNo" :disabled="true" :callback="handoverSelectCallback"></select-dialog-user>
      </template>

      <template slot-scope="{disabled,size}" slot="sealNoSearch">
        <el-input placeholder="請輸入印章編號" v-model="search.sealNo"></el-input>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getKeepList, getDetail, add, update, remove, getByNoAndType} from "@/api/bank/sealhandover";
  import {mapGetters} from "vuex";
  import { getCurrentDept } from "@/api/system/dept";
  import {dateFormat} from "../../util/date";
  import SelectDialogUser from "../../components/select-dialog/select-dialog-user";
  import {getDeptTree, getTree} from "@/api/system/dept";

  export default {
    name: "sealhandover-keep",
    components: {SelectDialogUser},
    data() {
      return {
        search: {},

        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          addBtn: false,
          editBtn: false,
          delBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "銀行號",
              prop: "bankNo",
              span: 24,
              hide: true,
              disabled: true,
              search: false,
              searchSpan: 4,
              rules: [{
                required: true,
                message: "請輸入銀行號",
                trigger: "blur"
              }]
            },
            {
              label: "機構號",
              prop: "orgNo",
              hide: true,
              disabled: true,
              rules: [{
                required: true,
                message: "請輸入機構號",
                trigger: "blur"
              }]
            },
            {
              label: "機構名稱",
              prop: "orgName",
              disabled: true,
              rules: [{
                required: true,
                message: "請輸入機構號",
                trigger: "blur"
              }]
            },
            {
              label: "印章類型",
              prop: "sealType",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=seal_type",
              props:{
                label: "dictValue",
                value: "dictKey",
              },
              /*dicFormatter: (res) => {
                res.data.forEach(item => {item.disabled = item.isSealed == 1;})
                return res.data;
              },*/
              search: true,
              searchMultiple: true,
              rules: [{
                required: true,
                message: "請輸入印章類型",
                trigger: "blur"
              }]
            },
            {
              label: "印章編號",
              prop: "sealNo",
              search: true,
              searchSpan: 4,
              searchslot: true,
              /*change: ({value, column}) => {
                if (!value) return;
                getByNoAndType(value, this.form.sealType, this.form.orgNo).then(res => {
                  const data = res.data.data;
                  let $handoverNo = this.findObject(this.option.column, 'handoverPersonNo');
                  if (Object.keys(data).length == 0){
                    // $handoverNo.disabled = false;
                    this.form.handoverPersonNo = '';
                    delete this.form.handoverPersonName;
                  } else {
                    // $handoverNo.disabled = true;
                    this.form.handoverPersonNo = data.receiverNo;
                    this.form.handoverPersonName = data.receiverName;
                  }
                });
              },*/
              rules: [{
                required: true,
                message: "請輸入印章編號",
                trigger: "blur"
              }]
            },
            {
              label: "區域/支行",
              prop: "orgNos",
              hide: true,
              display: false,
              searchMultiple: true,
              search: true,
              type: "tree",
              dicData: [],
              props: {
                label: "title",
                value: "key"
              },
              checkStrictly: true,
              rules: [{
                required: true,
                message: "請輸入機構號",
                trigger: "blur"
              }]
            },

            {
              label: "交出人",
              prop: "handoverPersonName",
              formslot: true,
              hide: true,
              rules: [{
                required: false,
                message: "請輸入交出人姓名",
                trigger: "change"
              }]
            },
            {
              label: "交出人員工號",
              prop: "handoverPersonNo",
              disabled: true,
              hide: true,
              rules: [{
                required: false,
                message: "請輸入交出人員工號",
                trigger: "blur"
              }]
            },
            {
              label: "開始保管日期",
              prop: "handoverDate",
              type: "datetime",
              format: "yyyy-MM-dd HH:mm",
              valueFormat: "yyyy-MM-dd HH:mm",
              rules: [{
                required: true,
                message: "請輸入交接日期",
                trigger: "blur"
              }]
            },
            {
              label: "保管人",
              prop: "receiverName",
              search: true,
              searchPlaceholder: "保管人",
              searchTip: "保管人",
              searchSpan: 4,
              formslot: true,
              rules: [{
                required: true,
                message: "請輸入接收人姓名",
                trigger: "change"
              }]
            },
            {
              label: "保管人員工號",
              prop: "receiverNo",
              rules: [{
                required: true,
                message: "請輸入接收人員工號",
                trigger: "blur"
              }]
            },
            {
              label: "備註",
              prop: "remark",
              hide: true,
              rules: [{
                required: false,
                message: "請輸入備註",
                trigger: "blur"
              }]
            },
            {
              label: "填報時間",
              prop: "fillingDate",
              addDisplay: false,
              editDisplay: false,
              hide: true,
              rules: [{
                required: true,
                message: "請輸入填報時間",
                trigger: "blur"
              }]
            },
            {
              label: "填報人",
              prop: "fillingPerson",
              addDisplay: false,
              editDisplay: false,
              hide: true,
              rules: [{
                required: true,
                message: "請輸入填報人",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      ...mapGetters(["userInfo"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.sealhandover_add, false),
          viewBtn: this.vaildData(this.permission.sealhandover_view, false),
          delBtn: this.vaildData(this.permission.sealhandover_delete, false),
          editBtn: this.vaildData(this.permission.sealhandover_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    created() {
      getDeptTree().then(res => {
        const column = this.findObject(this.option.column, "orgNos");
        let treeData = getTree(res.data.data, this.userInfo.dept_id);
        column.dicData = treeData;
      });
    },
    methods: {
      handleDownload(){
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }
        let columns = this.deepClone(this.option.column);
        for (let i = 0; i < columns.length; i++) {
          let item = columns[i];
          if (item.hide || item.prop == 'process'){
            columns.splice(i, 1);
            i--;
          }
          if (item.type == 'select' || item.type == 'tree'){
            item.prop = '$' + item.prop;
          }
        }
        this.$Export.excel({
          title: "業務印章保管人" || new Date().getTime(),
          columns: columns,
          data: this.selectionList
        });
      },
      handoverSelectCallback(value){
        this.form.handoverPersonNo = value.ehr;
        this.form.handoverPersonName = value.name;
      },
      selectCallback(value){
        this.form.receiverNo = value.ehr;
        this.form.receiverName = value.name;
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (type === 'add'){
          let userInfo = localStorage.getItem("saber-userInfo");
          this.form.number = 1;
          this.form.handoverDate = dateFormat(new Date(), "yyyy-MM-dd hh:mm");
          getCurrentDept().then(res => {
            const data =  res.data.data;
            this.form.bankNo = data.bankNo;
            this.form.orgNo = data.orgNo;
            this.form.orgName = data.deptName;
          });
        }

        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        if (params.sealType){
          params.sealType = params.sealType.join();
        }
        if (params.orgNos){
          params.orgNostr = params.orgNos.join();
          params.orgNos = '';
        }
        if (params.handoverDateRange){
          params.handoverDate_begin = params.handoverDateRange[0], params.handoverDate_end = params.handoverDateRange[1];
          params.handoverDateRange = null;
        }

        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        params.isTurnIn = 0;
        getKeepList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.data = data;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
